 /*:
 * @target MZ
 * @plugindesc Смещение окошка с именем при показе сообщения.
 * @author VarVarKa
 *
 * @command offsetX
 * @text Смещение окошка по X
 * @desc Значение в пикселях.
 *
 * @arg offset_x
 * @type number
 * @default 0
 * @text Смещение по X
 *
 * @command offsetY
 * @text Смещение окошка по Y
 * @desc Значение в пикселях.
 *
 * @arg offset_y
 * @type number
 * @default 0
 * @text Смещение по Y
 *
 * @param VarOffset
 * @type variable
 * @desc Переменная для хранения x,y смещений. По умолчанию: 20
 * @default 20
 *
 * @help
 * С помощью плагина можно смещать окошко с именем при показе сообщения.
 * Для этого используются команды плагина.
 * Также можно менять положение окошка через команду "Переменная...", используя
 * пункт скрипт, где в квадратных скобках указывается смещение сначала по X и Y.
 * Например, [0,5]
 *
 * !!!Плагин использует переменную для работы!!!
*/

(() => {
	const pluginName = 'BoxNameXYOffset'
	
	PluginManager.registerCommand(pluginName, 'offsetX', args => {
		var ox=Number(args.offset_x)||0
		var_is_arr()
		gV(varOffset)[0]=ox
	})
		
	PluginManager.registerCommand(pluginName, 'offsetY', args => {
		var oy=Number(args.offset_y)||0
		var_is_arr()
		gV(varOffset)[1]=oy
	})
})()

var parameters = PluginManager.parameters('BoxNameXYOffset')
var varOffset = Number(parameters['VarOffset'])||20
var Window_NameBox_updatePlacement = Window_NameBox.prototype.updatePlacement;
Window_NameBox.prototype.updatePlacement = function() {
    Window_NameBox_updatePlacement.call(this)
	var_is_arr()
	if (isNumber(gV(varOffset)[0])) this.x += gV(varOffset)[0]
	else this.x += 0
    if (isNumber(gV(varOffset)[1])) this.y += gV(varOffset)[1]
	else this.x += 0
}
 
function isArray (arr){
	if (Array.isArray(arr)) return true
	else return false
}

function isNumber (num){
	if (Number.isInteger(num)) return true
	else return false
}

function var_is_arr (){
	if (!isArray(gV(varOffset))) gVs(varOffset,[0,0])
}

function gV (num){
	return $gameVariables.value(num);
}

function gVs (num,value){
	$gameVariables.setValue(num, value);
}