/*:
 * @plugindesc Скрывает HP/MP в меню группы
 * @author RPG Maker MZ Help
 *
 * @help Этот плагин не требует настройки.
 */

(() => {

// Переопределение метода drawItemStatus для Window_MenuStatus
Window_MenuStatus.prototype.drawItemStatus = function(index) {
    const actor = this.actor(index);
    const rect = this.itemRect(index);
    const x = rect.x + 162;
    const y = rect.y + Math.floor(rect.height / 2 - this.lineHeight() * 1.5);

    this.drawActorName(actor, x, y);
    this.drawActorLevel(actor, x, y + this.lineHeight() * 1);
    this.drawActorIcons(actor, x, y + this.lineHeight() * 2);
    this.drawActorClass(actor, x + 180, y);
    this.placeTimeGauge(actor, x + 180, y + this.lineHeight());

    // Отрисовка индикаторов, кроме HP и MP
    if ($dataSystem.optDisplayTp) {
        this.placeGauge(actor, "tp", x + 180, y + this.lineHeight() * 2);
    }

    // Получение спрайтов HP/MP и их скрытие
    const gaugeSprites = this._additionalSprites;
    const hpGaugeKey = "actor" + actor.actorId() + "-gauge-hp";
    const mpGaugeKey = "actor" + actor.actorId() + "-gauge-mp";
    if (gaugeSprites[hpGaugeKey]) gaugeSprites[hpGaugeKey].hide();
    if (gaugeSprites[mpGaugeKey]) gaugeSprites[mpGaugeKey].hide();
};


// Переопределение метода drawItemStatus для Window_BattleStatus
Window_BattleStatus.prototype.drawItemStatus = function(index) {
    const actor = this.actor(index);
    const rect = this.itemRectWithPadding(index);
    const nameX = this.nameX(rect);
    const nameY = this.nameY(rect);
    const stateIconX = this.stateIconX(rect);
    const stateIconY = this.stateIconY(rect);
    // const basicGaugesX = this.basicGaugesX(rect); // Не используется, т.к. скрываем HP/MP
    // const basicGaugesY = this.basicGaugesY(rect); // Не используется, т.к. скрываем HP/MP

    this.placeTimeGauge(actor, nameX, nameY);
    this.placeActorName(actor, nameX, nameY);
    this.placeStateIcon(actor, stateIconX, stateIconY);
    // this.placeBasicGauges(actor, basicGaugesX, basicGaugesY);  // НЕ вызываем, т.к. скрываем HP/MP

    // TP gauge, if enabled and not hidden
    if ($dataSystem.optDisplayTp) {
        const tpGaugeX = this.basicGaugesX(rect);
        const tpGaugeY = this.basicGaugesY(rect) - 2 * this.gaugeLineHeight(); // Adjust Y position
        this.placeGauge(actor, "tp", tpGaugeX, tpGaugeY);
    }

    // Скрытие HP/MP  
    const basicGauges = this._additionalSprites;
    const hpGaugeKey = "actor" + actor.actorId() + "-gauge-hp";
    const mpGaugeKey = "actor" + actor.actorId() + "-gauge-mp";
   
    if(basicGauges[hpGaugeKey]){
        basicGauges[hpGaugeKey].hide();
    }
    if(basicGauges[mpGaugeKey]){
        basicGauges[mpGaugeKey].hide();
    }
};


})();