// создаем объект-плагин
var MyPlugin = {};

// добавляем функцию инициализации
MyPlugin.initialize = function() {
    // создаем кнопки сохранения и загрузки
    var saveBtn = new PIXI.Sprite();
    saveBtn.texture = ImageManager.loadSystem('Save');
    saveBtn.position.set(10, 10);
    saveBtn.interactive = true;
    saveBtn.on('pointerdown', this.saveGame.bind(this));
    SceneManager._scene.addChild(saveBtn);

    var loadBtn = new PIXI.Sprite();
    loadBtn.texture = ImageManager.loadSystem('Load');
    loadBtn.position.set(60, 10);
    loadBtn.interactive = true;
    loadBtn.on('pointerdown', this.loadGame.bind(this));
    SceneManager._scene.addChild(loadBtn);
};

// добавляем функцию сохранения игры
MyPlugin.saveGame = function() {
    StorageManager.save(Game_BattlerBase.prototype.currentClass().name + "_" + $gameSystem.playtimeText(), JSON.stringify($gameSystem));
};

// добавляем функцию загрузки игры
MyPlugin.loadGame = function() {
    var data = StorageManager.load(Game_BattlerBase.prototype.currentClass().name + "_" + $gameSystem.playtimeText());
    if (data) {
        $gameSystem = JSON.parse(data);
    }
    SceneManager.goto(Scene_Map);
};